// Gary Yngve 10/30/05

import java.io.*;
public class PrecomputedMineStrategy implements MineStrategy {

// load the precomputed data.  change the filenames for larger inputs.
    public PrecomputedMineStrategy() {
        try {
        MineWindow.exploreSet = MineWindow.read(new FileInputStream("explore-short.txt"));
    } catch (Exception e) { System.out.println(e); throw new RuntimeException("fileio error");}
        try {
        MineWindow.markSet = MineWindow.read(new FileInputStream("mark-short.txt"));
    } catch (Exception e) { System.out.println(e); throw new RuntimeException("fileio error");}
    }

    public int decide(MineBoard mb, int x, int y) {
        // for the sake of eliminating rotational symmetries
        // and reducing unneeded information, use a 5x5 window
        // but have the deciding square be off-center.  Do for all
        // four quadrants.
        for(int i = -1; i <= 1; i+=2)
            for(int j = -1; j <= 1; j+=2) {
                MineWindow mw = new MineWindow(mb,x+i,y+j,i,j);
                if (MineWindow.markSet.contains(mw)) {
                    return  MineStrategy.MARK;
                }
                else if (MineWindow.exploreSet.contains(mw)) {
                    return MineStrategy.EXPLORE;
                }
            }
        return MineStrategy.UNKNOWN; // only decide if 100% sure
    }
}
