// Gary Yngve 10/30/2005

public class RecordDeriveRuleMineStrategy implements MineStrategy {

    private int numGuesses; // number of trials that pass constraints

    public RecordDeriveRuleMineStrategy(int numGuesses) {
        this.numGuesses = numGuesses;
    }

    public int decide(MineBoard mb, int x, int y) {
        GuessWindow g = new GuessWindow(2);

        // for the sake of eliminating rotational symmetries
        // and reducing unneeded information, use a 5x5 window
        // but have the deciding square be off-center.  Do for all
        // four quadrants.
        for(int i = -1; i <= 1; i+=2)
            for(int j = -1; j <= 1; j+=2) {
                int sum = 0;
                for(int k = 0; k < numGuesses; k++) {
                    g.populateValidLayout(mb,x+i,y+j);
                    if (g.get(-i,-j)) // offset back to (0,0)
                        sum++;
                }
                if (sum == 0) {
                    MineWindow mw = new MineWindow(mb,x+i,y+j,i,j);
                    MineWindow.exploreSet.add(mw);
                    return MineStrategy.EXPLORE;
                }
                else if (sum == numGuesses) {
                    MineWindow mw = new MineWindow(mb,x+i,y+j,i,j);
                    MineWindow.markSet.add(mw);
                    return MineStrategy.MARK;
                }
            }
        return MineStrategy.UNKNOWN;
    }
}
